Option Strict Off
Option Explicit On
Module S1VStruct
	'Module for EX5-stuff
	
	
	
	Public Structure VoiceType 'structuur van de Voice SubChunk, zie tabel 11
        Dim Naam As String                              '12 0       (Lengte, offset)
        Dim Category As Byte                            '1  12      (rest = 236 - 12 = 224)
        Dim Volume As Byte                              '1  13
        Dim DrumLayerCount As Byte                      '1  14
        Dim VelocitySenseDepth As Byte                  '1  15
        Dim VelocitySenseOffset As Byte                 '1  16
        Dim ReverbSendLevel As Byte                     '1  17
        Dim ChorusSendLevel As Byte                     '1  18
        Dim ReverbType As Byte                          '1  19
        <VBFixedArray(12)> Dim ReverbParByte() As Byte  '1  20
        <VBFixedArray(2)> Dim ReverbParWord() As Short  '2  32
        Dim ReverbReturn As Byte                        '1  36
        Dim ReverbPan As Byte                           '1  37
        Dim Reserve1 As Byte                            '1  38
        Dim ChorusType As Byte                          '1  39
        <VBFixedArray(4)> Dim ChorusParWord() As Short  '2  40
        <VBFixedArray(8)> Dim ChorusParByte() As Byte   '1  48
        Dim ChorusReturn As Byte                        '1  56
        Dim ChorusPan As Byte                           '1  57
        Dim Chorus2Reverb As Byte                       '1  58
        Dim InsVoiceType As Byte                        '1  59
        Dim InsertionSType As Byte                      '1  60
        <VBFixedArray(15)> Dim InsertionSPar() As Byte  '1  61
        Dim FDSPPan As Byte                             '1  76
        Dim InsertionLType As Byte                      '1  77
        <VBFixedArray(16)> Dim InsertionLPar() As Short '2  78
        Dim ArpTempoControl As Byte                     '1  110
        Dim Reserve2 As Short                           '2  111
        Dim Ins2ReverbSendLevel As Byte                 '1  113
        Dim Ins2ChorusSendLevel As Byte                 '1  114
        Dim InsLargeSmallFDSPType As Byte               '1  115
        <VBFixedArray(20)> Dim FDSPPar() As Byte        '1  116
        Dim ModePortSW As Byte                          '1  136
        Dim PortamentTime As Byte                       '1  137
        Dim BendWheelAssignSW As Short                  '2  138
        Dim ModulationWheelAssignSW As Short            '2  140
        Dim CHAfterAssignSW As Short                    '2  142
        Dim ModulationWheel2AssignSW As Short           '2  144
        Dim FootControllerAssignSW As Short             '2  146
        Dim BreathControllerAssignSW As Short           '2  148
        Dim RibbonControllerAssignSW As Short           '2  150
        <VBFixedArray(6)> Dim KnobAssignSW() As Short   '2  152
        <VBFixedArray(16)> Dim VCControlDepth() As Byte '1  164
        <VBFixedArray(16)> Dim VCDestinationAssignNr() As Byte '1  180
        <VBFixedArray(16)> Dim VCDestinationAssignElem() As Byte '1  196
        Dim PitchBendUpperDepth As Byte                 '1  212
        Dim PichBendLowerDepth As Byte                  '1  213
        Dim Knob1Scene1 As Byte                         '1  214
        Dim Knob1Scene2 As Byte                         '1  215
        Dim Knob1Initial As Byte                        '1  216
        Dim Knob2Scene1 As Byte                         '1  217
        Dim Knob2Scene2 As Byte                         '1  218
        Dim Knob2Initial As Byte                        '1  219
        Dim Knob3Scene1 As Byte                         '1  220
        Dim Knob3Scene2 As Byte                         '1  221
        Dim Knob3Initial As Byte                        '1  222
        Dim Knob4Scene1 As Byte                         '1  223
        Dim Knob4Scene2 As Byte                         '1  224
        Dim Knob4Initial As Byte                        '1  225
        Dim Knob5Scene1 As Byte                         '1  226
        Dim Knob5Scene2 As Byte                         '1  227
        Dim Knob5Initial As Byte                        '1  228
        Dim Knob6Scene1 As Byte                         '1  229
        Dim Knob6Scene2 As Byte                         '1  230
        Dim Knob6Initial As Byte                        '1  231
        Dim ArpOnType As Byte                           '1  232
        Dim ArpNoteLimitLow As Byte                     '1  233
        Dim ArpNoteLimitHigh As Byte                    '1  234
        Dim ArpTempo As Byte                            '1  235
		

		Public Sub Initialize()
            ReDim ReverbParByte(12)
            ReDim ReverbParWord(2)
            ReDim ChorusParWord(4)
            ReDim ChorusParByte(8)
            ReDim InsertionSPar(15)
            ReDim InsertionLPar(16)
            ReDim FDSPPar(20)
            ReDim KnobAssignSW(6)
            ReDim VCControlDepth(16)
            ReDim VCDestinationAssignNr(16)
            ReDim VCDestinationAssignElem(16)
		End Sub
	End Structure
	
	
    Public Structure S1VType 'layout S1V file
        Dim Header As String '16
        Dim dummy As String '112
        <VBFixedArray(1024)> Dim ElementsIndex() As String '1024 * 2
        '    Voice(256) As VoiceType                 '256 * 236 verwijderd; werd te lang
        <VBFixedArray(1024)> Dim Element() As String '1024 * 132

        Public Sub Initialize()
            ReDim ElementsIndex(1024)
            ReDim Element(1024)
        End Sub
    End Structure

    Public Structure WaveHeaderType 'see description in Excelfile
        Dim name As String '8
        Dim Layers As Short '2
        Dim length As Integer '3
        Dim Layernumber As Short '1
        Dim dummy1 As String '16, TBD
    End Structure

    Public Structure SampleHeaderType 'see description in Excelfile
        Dim name As String '8
        Dim dummy1 As String '6, TBD
        Dim length As Integer '3
        Dim dummy2 As String '1, TBD
        Dim dummy3 As String '12
        Dim dummy4 As String '1002
    End Structure

    Public S1V As S1VType
    Public Voice(256) As VoiceType
    Public WaveHeader(1024) As WaveHeaderType
    Public SampleHeader(1024) As SampleHeaderType
End Module