Option Strict Off
Option Explicit On
Module SFStruct
	
	'In this module: Soundfont stuff
	Public Structure InfoChunkType
		Dim ifil As String
		Dim isng As String
		Dim irom As String
		Dim iver As String
		Dim INAM As String
		Dim ICRD As String
		Dim IENG As String
		Dim IPRD As String
		Dim ICOP As String
		Dim ICMT As String
		Dim ISTF As String
	End Structure
	
	Public Structure sfPresetHeaderType
		Dim achPresetName As String 'Preset name    20
		Dim wPreset As Short 'Preset number  2
		Dim wBank As Short 'Bank number    2
		Dim wPresetBagNdx As Integer 'Index in PBAG  4
		Dim nZones As Short '# zones, calculate
		Dim pFirstZone As Integer 'points to first zone
	End Structure
	
	Public Structure sfPresetBagType
		Dim wGenNdx As Integer 'Index to generator
		Dim nGen As Short 'number of gnerators
		Dim wModNdx As Integer 'Index to modulators
		Dim nMod As Short 'number of modulators
		Dim PresetHeaderNr As Integer 'pointer to preset where this zone belongs to
	End Structure
	
	Public Structure sfInstrType
		Dim achInstName As String 'Instrument naam 20
		Dim wInstBag As Short 'index 2
		Dim nZones As Short 'number of instrument zones
		Dim iFirstZone As Integer 'points to first zone
	End Structure
	
	Public Structure sfInstrBagType
		Dim wInstGenNdx As Integer 'Index to generator
		Dim nInstGen As Short 'number of gnerators
		Dim wInstModNdx As Integer 'Index to modulators
		Dim nInstMod As Short 'number of modulators
		Dim InstrNr As Integer 'pointer to instrument where this zone belongs to
	End Structure
	
	Public Structure sfPModListType
		Dim sfModSrcOper As Integer
		Dim sfModDestOper As Integer
		Dim modAmount As Integer
		Dim sfModAmtSrcOper As Integer
		Dim sfModTransOper As Integer
		Dim PBagNr As Short 'pointer to presetzone
	End Structure
	
	Public Structure sfIModListType
		Dim sfModSrcOper As Integer
		Dim sfModDestOper As Integer
		Dim modAmount As Integer
		Dim sfModAmtSrcOper As Integer
		Dim sfModTransOper As Integer
		Dim IBagNr As Short 'pointer to presetzone
	End Structure
	
	Public Structure sfSampleType
        Dim SampleName As String    'sample name    20
        Dim dwStart As Integer       '               4
        Dim dwEnd As Integer         '               4
		Dim dwStartLoop As Integer
		Dim dwEndLoop As Integer
		Dim dwSampleRate As Integer
        Dim byOriginalKey As Char
        Dim chCorrection As Char
		Dim wSampleLink As Short
        Dim sfSampleType As Integer
	End Structure
	
	Public Structure SFStructure
		Dim ckRIFFlen As Integer 'RIFF size (= filesize - 8)
		Dim ckINFOLen As Integer 'size of INFO chunk
		Dim ckSDTALen As Integer 'Size of SDTA chunk
		Dim smplLen As Integer 'Size of samples
		Dim phdrLen As Integer 'Size of phdr
	End Structure
	
	Public Structure sfPGenListType
        Dim sfGenOper As Integer
		Dim genAmount As Integer
		Dim PBagNr As Short 'pointer to presetzone
	End Structure
	
	Public Structure sfIGenListType
		Dim sfGenOper As Integer
		Dim genAmount As Integer
		Dim IBagNr As Short 'pointer to Instrumentzone
	End Structure
	
	Public Structure ValueType 'user defined type as argument in procedures
        Dim waarde As String
	End Structure
	
	Public Structure InstrParamType
		<VBFixedArray(2048)> Dim SampleNdx() As Short 'index to sample
		Dim LayerCount As Short 'index to n'th layer within instrument
		<VBFixedArray(2048)> Dim LowKey() As Short
		<VBFixedArray(2048)> Dim HighKey() As Short
		<VBFixedArray(2048)> Dim VelLow() As Short
		<VBFixedArray(2048)> Dim VelHigh() As Short
		<VBFixedArray(2048)> Dim coarseTune() As Short
		<VBFixedArray(2048)> Dim fineTune() As Short
		<VBFixedArray(2048)> Dim OverridingRootKey() As Short
		<VBFixedArray(2048)> Dim samplemode() As Short
		<VBFixedArray(2048)> Dim pan() As Short
		<VBFixedArray(128)> Dim globalzone() As Boolean
		
		Public Sub Initialize()
			ReDim SampleNdx(2048)
			ReDim LowKey(2048)
			ReDim HighKey(2048)
			ReDim VelLow(2048)
			ReDim VelHigh(2048)
			ReDim coarseTune(2048)
			ReDim fineTune(2048)
			ReDim OverridingRootKey(2048)
			ReDim samplemode(2048)
			ReDim pan(2048)
			ReDim globalzone(128)
		End Sub
	End Structure
	
	
    Public sFile As String 'name input file
    Public oFile As String 'name output File
	Public fMainForm As frmMain
	Public InstrParams(512) As InstrParamType
	Public value As ValueType
	Public SF As SFStructure
	Public INFOChunk As InfoChunkType
	Public sfPModList(4096) As sfPModListType
	Public sfIModList(4096) As sfIModListType
	Public sfPGenList(4096) As sfPGenListType
	Public sfIGenList(64000) As sfIGenListType
	Public sfSample(2048) As sfSampleType 'samples
    Public nPresets As Integer
    Public nInstruments As Integer
    Public nsamples As Integer
	Public sfInstr(512) As sfInstrType
	Public lFileLen As Integer 'Length of inputfile
	Public bTel As Integer 'Number of bytes read
    Public shFileName As String 'short filename (without pathinfo)
    Public shFileNoExt As String 'short filename without extension
    Public shPath As String 'Path of input file
	Public sfPresetBag(2048) As sfPresetBagType
	Public sfInstrBag(4096) As sfInstrBagType
    Public nPZones As Integer 'number of preset Zones
    Public nIZones As Integer 'number of instrument zones
    Public nPMods As Integer 'number of modulators in P-zone
    Public nPGens As Integer 'number of generators in P-zone
    Public nIMods As Integer 'number of modulators in I-zone
    Public nIGens As Integer 'number of generators in I-zone
    Public NodSelect As New TreeNode
    Public InstrumentNode As New TreeNode
	Public sfPresetHeader(512) As sfPresetHeaderType 'preset headers
	Public strtSampleData As Integer 'Start of Sample data in file
    Public NodX As New TreeNode  'different nodes in TreeView
    Public Nod0 As New TreeNode
    Public NodP As New TreeNode
    Public NodI As New TreeNode
    Public NodS As New TreeNode
    Dim dummy As String 'used to skip bytes
	Public GenDesc(60) As String
	Public KeyDesc(11) As String
	
	Sub LeesSFBestand()
		'lees een soundfont bestand in
		
        Dim lang As Integer 'Length of record read
		Dim i As Integer 'counter
		Dim j As Integer 'counter
		Dim k As Integer 'counter
		Dim sStatus As String 'Message fot statusbar
		Dim it As MSComctlLib.ListItem
		Dim s As String
		
		On Error GoTo 0
		System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
		'Get File Length
        lFileLen = FileLen(sFile)
		bTel = 0
		
		'handle user interface
        'fMainForm.sbStatusBar.Panels(1)._ObjectDefault = "Processing..."
        fMainForm.sbStatusBar.Panels(1).Text = "Processing..."
        fMainForm.TreeView1.Nodes.Clear()
        fMainForm.TreeView1.BeginUpdate()
		fMainForm.Text = "SF2S1"
		fMainForm.Refresh()
		
		'read all the different chunks
		Call RIFFChunk() 'start reading Soundfontfile
		Call SubINFOChunk() 'process Info chunk
		Call SMPLChunk() 'process sample data
		Call PHDRChunk() 'process preset header
		Call PBAGChunk() 'read presetbag
		Call PMODChunk() 'process Preset modulators
		Call PGENchunk() 'process Preset generators
		Call INSTChunk() 'proces instrument header data
		Call IBAGChunk() 'proces Instrument Bag
		Call IMODChunk() 'process Instrument modulators
		Call IGENchunk() 'process Instrument generators
		Call SHDRChunk() 'process Sample header data
		
		'    Work on User inteface
		Call POPInstrNames()
        Call PopSampleNames()

        'set treeview to see presets/instruments/samples
        fMainForm.TreeView1.CollapseAll()
        NodP.EnsureVisible()
        fMainForm.TreeView1.EndUpdate()

		'write result in statusbar
        sStatus = Str(nPresets) & " presets, " & Str(nInstruments) & " instruments, "
        sStatus = sStatus & Str(nsamples) & " samples, one moment please..."
        fMainForm.sbStatusBar.Panels(1).Text = sStatus
		
		'write filename in formheader
        fMainForm.Text = "SF2S1 - " + shFileName
		fMainForm.Refresh()
		System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
	End Sub
	
    Function lengte() As Integer
        'Reads 4 bytes and interprets as a number
        'little indean
        Dim som As Integer
        Dim a(4) As Char
        Dim i As Integer
        som = 0
        For i = 1 To 4
            a(i) = InputString(1, 1)
            som = som + Asc(a(i)) * (256 ^ (i - 1))
        Next i
        lengte = som
    End Function

    Function ReadWord() As Integer
        'reads the next 2 bytes and interprets as a number
        'little indean
        Dim som As Integer
        Dim a(2) As Char
        Dim i As Integer
        som = 0
        For i = 1 To 2
            a(i) = InputString(1, 1)
            som = som + Asc(a(i)) * (256 ^ (i - 1))
        Next i
        ReadWord = som
    End Function

    Sub CheckChunk(ByRef chunk As String)
        'check if a required chunk is available, if not stop program
        Dim s As String
        s = InputString(1, 4)
        If Not (StrComp(s, chunk) = 0) Then
            MsgBox("Error in SoundFont File. Program will End")
            End
        End If
    End Sub
    Sub RIFFChunk()
        'process start of soundfontfile
        CheckChunk(("RIFF")) 'RIFF?
        SF.ckRIFFlen = lengte()
        CheckChunk(("sfbk")) 'sfbk?
        CheckChunk(("LIST")) '"LIST"
        SF.ckINFOLen = lengte() 'lengte van INFO-list
        CheckChunk(("INFO"))
    End Sub

    Sub SubINFOChunk()
        'Processes INFO chunck
        Dim chunkname As String
        Dim i As Integer
        Dim j As Integer
        Dim BR As Integer
        Do
            chunkname = InputString(1, 4)
            Select Case chunkname
                Case "ifil"
                    BR = lengte() 'skip sizebytes
                    i = ReadWord()
                    j = ReadWord()
                    INFOChunk.ifil = Str(i + j / 100)
                Case "isng"
                    BR = lengte()
                    INFOChunk.isng = InputString(1, BR)
                Case "irom"
                    BR = lengte()
                    INFOChunk.irom = InputString(1, BR)
                Case "iver"
                    BR = lengte() 'skip sizebytes
                    i = ReadWord()
                    j = ReadWord()
                    INFOChunk.iver = Str(i + j / 100)
                Case "INAM"
                    BR = lengte()
                    INFOChunk.INAM = InputString(1, BR)
                Case "IPRD"
                    BR = lengte()
                    INFOChunk.IPRD = InputString(1, BR)
                Case "ICRD"
                    BR = lengte()
                    INFOChunk.ICRD = InputString(1, BR)
                Case "IENG"
                    BR = lengte()
                    INFOChunk.IENG = InputString(1, BR)
                Case "ICOP"
                    BR = lengte()
                    INFOChunk.ICOP = InputString(1, BR)
                Case "ICMT"
                    BR = lengte()
                    INFOChunk.ICMT = InputString(1, BR)
                Case "ISFT"
                    BR = lengte()
                    INFOChunk.ISTF = InputString(1, BR)
            End Select
        Loop Until chunkname = "LIST"
    End Sub

    Sub SMPLChunk()
        'process sample data
        Dim fLoc As Integer 'File Location
        SF.ckSDTALen = lengte()
        CheckChunk(("sdta")) 'check "sdta"
        CheckChunk(("smpl")) 'check "smpl"
        SF.smplLen = lengte()
        fLoc = Seek(1) 'skip sampledata...
        strtSampleData = fLoc '...but keep startbyte in mind (first byte = 1)
        fLoc = fLoc + SF.smplLen
        Seek(1, fLoc)
    End Sub
    Sub PHDRChunk()
        'process phdr chunck
        'populate with presets
        Dim i As Integer
        Dim lang As Integer
        CheckChunk(("LIST")) 'skip "LIST"
        lang = lengte() 'skip size bytes
        CheckChunk(("pdta")) ' check pdta chunk
        CheckChunk(("phdr")) 'skip "phdr"
        SF.phdrLen = lengte()
        'write level 1 nodes
        Nod0 = fMainForm.TreeView1.Nodes.Add(shFileName)
        fMainForm.TreeView1.SelectedNode = Nod0
        NodP = fMainForm.TreeView1.SelectedNode.Nodes.Add("Presets")
        NodP.ImageIndex = 2
        NodP.SelectedImageIndex = 2
        NodP.Tag = "NodeP"
        NodI = fMainForm.TreeView1.SelectedNode.Nodes.Add("Instruments")
        NodI.ImageIndex = 1         'instrument
        NodI.SelectedImageIndex = 1
        NodI.Tag = "NodeI"
        NodS = fMainForm.TreeView1.SelectedNode.Nodes.Add("Samples")
        NodS.ImageIndex = 3
        NodS.SelectedImageIndex = 3
        NodS.Tag = "NodeS"
        fMainForm.TreeView1.ExpandAll()
        i = 0
        nPZones = 0

        fMainForm.TreeView1.SelectedNode = NodP
        Do  'read phdr and populate treeview
            i = i + 1 '= number of presets
            sfPresetHeader(i).achPresetName = InputCheck(1, 20)
            sfPresetHeader(i).wPreset = ReadWord()
            sfPresetHeader(i).wBank = ReadWord()
            sfPresetHeader(i).wPresetBagNdx = ReadWord()
            dummy = InputString(1, 12) 'skip rest preset 3 * doubleword
            If i > 1 Then 'calculate # zones, from i = 2
                sfPresetHeader(i - 1).nZones = sfPresetHeader(i).wPresetBagNdx - sfPresetHeader(i - 1).wPresetBagNdx
                nPZones = nPZones + sfPresetHeader(i - 1).nZones
                'Set NodX = fMainForm.TreeView1.Nodes.Add("nodeP" + CStr(i - 1), _
                'tvwChild, "zones" + CStr(i - 1), Str(sfPresetHeader(i - 1).nZones) _
                '+ " zones", 1)
            End If
            If Mid(sfPresetHeader(i).achPresetName, 1, 3) = "EOP" Then Exit Do
            NodX = fMainForm.TreeView1.SelectedNode.Nodes.Add(sfPresetHeader(i).achPresetName)
            NodX.ImageIndex = 2
            NodX.SelectedImageIndex = 2
            NodX.Tag = "NodeP" & CStr(i)
        Loop
        nPresets = i - 1 'last preset header is dummy

    End Sub
    Sub PMODChunk()
        'process PMOD chunk
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim lang As Integer
        Dim nbytes As Integer

        CheckChunk(("pmod")) 'test if pmod-rec
        lang = lengte() 'read size

        k = 0
        nbytes = 0
        For i = 1 To nPZones 'i = PZonenumber
            For j = 1 To sfPresetBag(i).nMod 'j = Modulatornumber in PZone
                k = k + 1 'k =  number of modulators
                sfPModList(k).sfModSrcOper = ReadWord()
                sfPModList(k).sfModDestOper = ReadWord()
                sfPModList(k).modAmount = ReadWord()
                sfPModList(k).sfModAmtSrcOper = ReadWord()
                sfPModList(k).sfModTransOper = ReadWord()
                sfPModList(k).PBagNr = i 'pointer back to bag where modulator belongs
                nbytes = nbytes + 10 '= number of bytes read in pmod chunk
            Next j
        Next i
        'nPGens = MsgBox(Str(k), , "Number of Modulators in pGen")
        dummy = InputString(1, 10) 'read last dummy record
    End Sub
    Sub init()
        'init global variables
        Dim i As Integer : Dim j As Integer
        nPresets = 0
        nPZones = 0
        nInstruments = 0
        nsamples = 0
        nInstruments = 0
        nPMods = 0
        nPGens = 0
        Call FillGenDesc()
        Call InitKeyDesc()
        For i = 1 To 512
            InstrParams(i).Initialize()
            For j = 1 To 2048
                InstrParams(i).OverridingRootKey(j) = -1
                InstrParams(i).VelLow(j) = 1
                InstrParams(i).VelHigh(j) = 127
            Next j
            For j = 1 To 128
                InstrParams(i).globalzone(j) = False
            Next j
        Next i
        'For i = 1 To 2048
        '    sfSample(i).byOriginalKey = 60
        'Next i
    End Sub
    Sub PGENchunk()
        'read PGEN chunk
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim nbytes As Integer
        Dim lang As Integer
        CheckChunk(("pgen")) 'pgen-rec
        lang = lengte()
        i = 0
        j = 0
        k = 0
        nbytes = 0
        For i = 1 To nPZones 'i = PZonenumber
            For j = 1 To sfPresetBag(i).nGen 'j = Generatornumber in PZone
                k = k + 1 'k =  number of generators
                sfPGenList(k).sfGenOper = ReadWord()
                sfPGenList(k).genAmount = ReadWord()
                sfPGenList(k).PBagNr = i 'pointer back to bag where generator belongs
                nbytes = nbytes + 4 '= number of bytes read in pgen chunk
            Next j
        Next i
        'nPGens = MsgBox(Str(k), , "Number of Generators in pGen")
        dummy = InputString(1, 4) 'read last dummy record

    End Sub

    Sub PBAGChunk()
        'process zones in PBAG chunk
        Dim lang As Integer
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim PName As String

        CheckChunk(("pbag")) 'pbag-rec
        lang = lengte()
        For i = 1 To nPZones + 1 'one more to process terminal zone
            sfPresetBag(i).wGenNdx = ReadWord()
            sfPresetBag(i).wModNdx = ReadWord()
        Next i
        ' Dummy = Input(4, #1)         'read last dummy record

        'identify  zones per preset
        k = 0
        nPMods = 0
        nPGens = 0
        For i = 1 To nPresets 'i = presetnumber
            'write preset in tree
            sfPresetHeader(i).pFirstZone = k + 1
            PName = sfPresetHeader(i).achPresetName
            For j = 1 To sfPresetHeader(i).nZones 'j = zonenumber within presetzone
                k = k + 1 'k is actual zonenumber in pbag
                sfPresetBag(k).PresetHeaderNr = i 'set pointer back to preset
                'locate NodP to add children to
                fMainForm.TreeView1.SelectedNode = NodP
                For Each tvn As TreeNode In fMainForm.TreeView1.SelectedNode.Nodes
                    'MsgBox(tvn.Text)
                    If tvn.Text = PName Then
                        fMainForm.TreeView1.SelectedNode = tvn
                        NodX = fMainForm.TreeView1.SelectedNode.Nodes.Add("PGene" & CStr(k))
                        NodX.ImageIndex = 1
                        NodX.SelectedImageIndex = 1
                        NodX.Tag = "PGene" & CStr(k)
                        Exit For
                    End If
                Next
                If k > 1 Then 'calculate # mods end gens, starting from k = 2
                    sfPresetBag(k - 1).nMod = sfPresetBag(k).wModNdx - sfPresetBag(k - 1).wModNdx
                    nPMods = nPMods + sfPresetBag(k - 1).nMod
                    sfPresetBag(k - 1).nGen = sfPresetBag(k).wGenNdx - sfPresetBag(k - 1).wGenNdx
                    nPGens = nPGens + sfPresetBag(k - 1).nGen
                End If
            Next j
        Next i
        'process terminal zone
        k = k + 1
        If k > 1 Then
            sfPresetBag(k - 1).nMod = sfPresetBag(k).wModNdx - sfPresetBag(k - 1).wModNdx
            nPMods = nPMods + sfPresetBag(k - 1).nMod
            sfPresetBag(k - 1).nGen = sfPresetBag(k).wGenNdx - sfPresetBag(k - 1).wGenNdx
            nPGens = nPGens + sfPresetBag(k - 1).nGen
        End If
    End Sub
    Sub INSTChunk()
        'read Instrument chunk
        Dim i As Integer
        Dim lang As Integer
        CheckChunk(("inst")) 'inst-rec
        lang = lengte()
        i = 0
        nIZones = 0
        Do  'lees instrumentrecords en zet in tree
            i = i + 1
            sfInstr(i).achInstName = InputCheck(1, 20)
            'If EOF(1) Then Exit Do
            sfInstr(i).wInstBag = ReadWord()
            If i > 1 Then 'calculate # zones, from i = 2
                sfInstr(i - 1).nZones = sfInstr(i).wInstBag - sfInstr(i - 1).wInstBag
                nIZones = nIZones + sfInstr(i - 1).nZones
                'Set NodX = fMainForm.TreeView1.Nodes.Add("nodeI" + CStr(i - 1), _
                'tvwChild, "izone" + CStr(i - 1), Str(sfInstr(i - 1).nZones) _
                '+ " zones", 1)
            End If
            If Mid(sfInstr(i).achInstName, 1, 3) = "EOI" Then Exit Do
            fMainForm.TreeView1.SelectedNode = NodI
            NodX = fMainForm.TreeView1.SelectedNode.Nodes.Add(sfInstr(i).achInstName)
            NodX.ImageIndex = 1
            NodX.SelectedImageIndex = 1
            NodX.Tag = "NodeI" & CStr(i)
        Loop
        nInstruments = i - 1 'last is dummy record
    End Sub
    Sub IBAGChunk()
        'process zones in PBAG chunk, copied and modified from PBAGChunk
        'IBAG contains instrument (zones)
        Dim lang As Integer
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim IName As String

        CheckChunk(("ibag")) 'ibag-rec
        lang = lengte()
        For i = 1 To nIZones + 1 'one more to process terminal zone
            sfInstrBag(i).wInstGenNdx = ReadWord()
            sfInstrBag(i).wInstModNdx = ReadWord()
        Next i


        'identify zones per Instrument
        k = 0
        nIMods = 0
        nIGens = 0
        For i = 1 To nInstruments 'i = instrumentnumber
            'write instrument in tree
            sfInstr(i).iFirstZone = k + 1
            IName = sfInstr(i).achInstName
            For j = 1 To sfInstr(i).nZones 'j = zonenumber within instr.zone
                k = k + 1 'k is actual zonenumber in pbag
                'Set NodX = fMainForm.TreeView1.Nodes.Add("izone" + CStr(i), tvwChild, _
                '"IModu" + CStr(k), "Mod " + CStr(j), 1)
                'moet nog: NodX = fMainForm.TreeView1.Nodes.Add("nodeI" & CStr(i), MSComctlLib.TreeRelationshipConstants.tvwChild, "IGene" & CStr(k), "Gen " & CStr(j), 22)
                sfInstrBag(k).InstrNr = i 'set pointer back to instrument
                'locate NodI to add children to
                fMainForm.TreeView1.SelectedNode = NodI
                For Each tvn As TreeNode In fMainForm.TreeView1.SelectedNode.Nodes
                    'MsgBox(tvn.Text)
                    If tvn.Text = IName Then
                        fMainForm.TreeView1.SelectedNode = tvn
                        NodX = fMainForm.TreeView1.SelectedNode.Nodes.Add("IGene" & CStr(k))
                        NodX.ImageIndex = 3
                        NodX.SelectedImageIndex = 3
                        NodX.Tag = "IGene" & CStr(k)
                        Exit For
                    End If
                Next

                If k > 1 Then 'calculate # mods and gens, starting from k = 2
                    sfInstrBag(k - 1).nInstMod = sfInstrBag(k).wInstModNdx - sfInstrBag(k - 1).wInstModNdx
                    nIMods = nIMods + sfInstrBag(k - 1).nInstMod
                    sfInstrBag(k - 1).nInstGen = sfInstrBag(k).wInstGenNdx - sfInstrBag(k - 1).wInstGenNdx
                    nIGens = nIGens + sfInstrBag(k - 1).nInstGen
                End If
            Next j
        Next i
        'process terminal zone
        k = k + 1
        If k > 1 Then
            sfInstrBag(k - 1).nInstMod = sfInstrBag(k).wInstModNdx - sfInstrBag(k - 1).wInstModNdx
            nIMods = nIMods + sfInstrBag(k - 1).nInstMod
            sfInstrBag(k - 1).nInstGen = sfInstrBag(k).wInstGenNdx - sfInstrBag(k - 1).wInstGenNdx
            nIGens = nIGens + sfInstrBag(k - 1).nInstGen
        End If
    End Sub

    Sub IMODChunk()
        'process PMOD chunk
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim lang As Integer
        Dim nbytes As Integer

        CheckChunk(("imod")) 'test if imod-rec
        lang = lengte() 'read size

        k = 0
        nbytes = 0
        For i = 1 To nIZones 'i = IZonenumber
            For j = 1 To sfInstrBag(i).nInstMod 'j = Modulatornumber in IZone
                k = k + 1 'k =  number of modulators
                sfIModList(k).sfModSrcOper = ReadWord()
                sfIModList(k).sfModDestOper = ReadWord()
                sfIModList(k).modAmount = ReadWord()
                sfIModList(k).sfModAmtSrcOper = ReadWord()
                sfIModList(k).sfModTransOper = ReadWord()
                sfIModList(k).IBagNr = i 'pointer back to bag where modulator belongs
                nbytes = nbytes + 10 '= number of bytes read in pmod chunk
            Next j
        Next i
        'nPGens = MsgBox(Str(k), , "Number of Modulators in pGen")
        dummy = InputString(1, 10) 'read last dummy record
    End Sub

    Sub IGENchunk()
        'read IGEN chunk
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim nbytes As Integer
        Dim lang As Integer

        CheckChunk(("igen")) 'igen-rec
        lang = lengte()
        i = 0
        j = 0
        k = 0
        nbytes = 0
        For i = 1 To nIZones 'i = IZonenumber
            For j = 1 To sfInstrBag(i).nInstGen 'j = Generatornumber in IZone
                k = k + 1 'k =  number of generators
                sfIGenList(k).sfGenOper = ReadWord()
                sfIGenList(k).genAmount = ReadWord()
                sfIGenList(k).IBagNr = i 'pointer back to bag where generator belongs
                nbytes = nbytes + 4 '= number of bytes read in pmod chunk
            Next j
        Next i
        'nIGens = MsgBox(Str(k), , "Number of Generators in IGen")
        dummy = InputString(1, 4) 'read last dummy record
    End Sub

    Sub SHDRChunk()
        'proces shdr chunk

        Dim i As Integer
        Dim lang As Integer
        CheckChunk(("shdr")) 'shdr-rec
        lang = lengte()
        i = 0
        Do  'populate TreeView with samples
            i = i + 1
            sfSample(i).SampleName = InputCheck(1, 20)
            sfSample(i).dwStart = lengte()
            sfSample(i).dwEnd = lengte()
            sfSample(i).dwStartLoop = lengte()
            sfSample(i).dwEndLoop = lengte()
            sfSample(i).dwSampleRate = lengte()
            sfSample(i).byOriginalKey = InputString(1, 1)
            sfSample(i).chCorrection = InputString(1, 1)
            sfSample(i).wSampleLink = ReadWord()
            sfSample(i).sfSampleType = ReadWord()
            If EOF(1) Then Exit Do
            If Mid(sfSample(i).SampleName, 1, 3) = "EOS" Then Exit Do
            fMainForm.TreeView1.SelectedNode = NodS
            NodX = fMainForm.TreeView1.SelectedNode.Nodes.Add(sfSample(i).SampleName)
            NodX.ImageIndex = 3
            NodX.SelectedImageIndex = 3
            NodX.Tag = ("NodeS" & CStr(i))
        Loop
        nsamples = i - 1
    End Sub

    Sub PopSampleNames()
        'populate sample names in Treeview
        'inspect all Zones and fill Instrument Parameters (InstrParams)
        'identify global zones
        'interpret instrument generators

        Dim i As Short : Dim j As Short : Dim k As Integer
        Dim l As Short : Dim m As Short : Dim n As Short
        Dim IZone As Short
        Dim SampleName As String
        Dim found As Boolean
        k = 0 : IZone = 0
        'reset LayerCount per Instrument (needed if new SF read)
        For i = 1 To 512
            InstrParams(i).LayerCount = 0
        Next i

        For m = 1 To nInstruments 'go through all instruments
            InstrParams(m).LayerCount = sfInstr(m).nZones
            For i = 1 To sfInstr(m).nZones 'walk through Zones per instrument
                IZone = IZone + 1 'Izone = cumulative zonenumber
                For j = 1 To sfInstrBag(IZone).nInstGen 'go through generators / zone
                    'j = sfInstrBag(i).nInstGen          'j = last Generatornumber in IZone
                    k = k + 1 'keep track of cumulative number
                    SampleName = "global"
                    l = sfIGenList(k).IBagNr 'path back to Instrument Bag
                    'n = sfInstrBag(l).InstrNr       'path back to Instrument


                    Select Case sfIGenList(k).sfGenOper 'process different generators

                        Case 17 'pan
                            If sfIGenList(k).genAmount > 32678 Then
                                InstrParams(m).pan(i) = (65536 - sfIGenList(k).genAmount) * -1
                            Else
                                InstrParams(m).pan(i) = sfIGenList(k).genAmount
                            End If

                        Case 43 'keyRange generator
                            InstrParams(m).HighKey(i) = Int(sfIGenList(k).genAmount / 256)
                            InstrParams(m).LowKey(i) = Int(sfIGenList(k).genAmount - InstrParams(m).HighKey(i) * 256)

                        Case 44 'Velocity Range generator
                            InstrParams(m).VelHigh(i) = Int(sfIGenList(k).genAmount / 256)
                            InstrParams(m).VelLow(i) = Int(sfIGenList(k).genAmount - InstrParams(m).HighKey(i) * 256)

                        Case 51 'coarse Tune
                            If sfIGenList(k).genAmount > 32678 Then
                                InstrParams(m).coarseTune(i) = (65536 - sfIGenList(k).genAmount) * -1
                            Else
                                InstrParams(m).coarseTune(i) = sfIGenList(k).genAmount
                            End If

                        Case 52 'fine Tune
                            If sfIGenList(k).genAmount > 32678 Then
                                InstrParams(m).fineTune(i) = (65536 - sfIGenList(k).genAmount) * -1
                            Else
                                InstrParams(m).fineTune(i) = sfIGenList(k).genAmount
                            End If

                        Case 53 'SamplID generator?
                            SampleName = IntGen(sfIGenList(k).sfGenOper, sfIGenList(k).genAmount)
                            InstrParams(m).SampleNdx(i) = sfIGenList(k).genAmount + 1

                        Case 54 'SampleMode
                            InstrParams(m).samplemode(i) = sfIGenList(k).genAmount

                        Case 58 'overriding Root Key present?
                            InstrParams(m).OverridingRootKey(i) = sfIGenList(k).genAmount

                    End Select
                Next j

                found = False
                fMainForm.TreeView1.SelectedNode = NodI
                For Each tvn As TreeNode In NodI.Nodes
                    For Each subnode As TreeNode In tvn.Nodes
                        If subnode.Text = "IGene" & CStr(l) Then
                            subnode.Text = SampleName
                            subnode.Tag = CStr("IGene" & CStr(l))
                            found = True
                            Exit For
                        End If
                    Next
                    If found Then Exit For
                Next

                'fMainForm.TreeView1.Nodes("IGene" & CStr(IZone)).Text = SampleName
                If SampleName = "global" Then 'exclude global zone from processing
                    InstrParams(m).globalzone(i) = True
                End If

            Next i
        Next m
    End Sub

    Sub POPInstrNames()
        'populate Instrument names in Treeview
        Dim i As Integer : Dim j As Integer : Dim k As Integer
        Dim InstrName As String
        Dim found As Boolean

        k = 0
        For i = 1 To nPZones 'walk through all IZones
            j = sfPresetBag(i).nGen 'j = last Generatornumber in PZone
            k = k + j 'keep track of cumulative number
            'write instrument name in Treeview (or) 'Global'
            If sfPGenList(k).sfGenOper = 41 Then 'Instrument generator?
                InstrName = IntGen(sfPGenList(k).sfGenOper, sfPGenList(k).genAmount)
            Else
                InstrName = "global"
            End If
            'MsgBox InstrName

            found = False
            fMainForm.TreeView1.SelectedNode = NodP
            For Each tvn As TreeNode In NodP.Nodes
                For Each subnode As TreeNode In tvn.Nodes
                    If subnode.Text = "PGene" & CStr(k) Then
                        subnode.Text = InstrName
                        subnode.Tag = CStr("PGene" & CStr(k))
                        found = True
                        Exit For
                    End If
                Next
                If found Then Exit For
            Next

            'fMainForm.TreeView1.Nodes("PGene" & CStr(i)).Text = InstrName  (VB6 treeview)
        Next i
    End Sub

    Function IntGen(ByRef PGen As Integer, ByRef Amount As Integer) As String
        'interpret value of generator parameter
        Dim LS As Short
        Dim MS As Short
        IntGen = CStr(Amount) 'if not recognized just return value
        Select Case PGen 'if recognized as...

            Case 17 'pan
                If Amount > 32678 Then
                    value.waarde = (65536 - Amount) * -1
                Else
                    value.waarde = Amount
                End If
                IntGen = CStr(value.waarde)

            Case 43 'KeyRange
                MS = Int(Amount / 256) 'MS = to key
                LS = Int(CDbl(Amount - MS * 256)) 'LS = from key
                value.waarde = KeyStr(LS) & " - " & KeyStr(MS) & " / " & CStr(LS) & " - " & CStr(MS)
                IntGen = value.waarde

            Case 41 'instrument
                value.waarde = sfInstr(Amount + 1).achInstName 'lookup instrumentname
                IntGen = value.waarde

            Case 44 'Velocity Range
                MS = Int(Amount / 256) 'MS = to key
                LS = Int(CDbl(Amount - MS * 256)) 'LS = from key
                value.waarde = CStr(LS) & " - " & CStr(MS)
                IntGen = value.waarde

            Case 52 'fine Tune
                If Amount > 32678 Then
                    value.waarde = (65536 - Amount) * -1
                Else
                    value.waarde = Amount
                End If
                IntGen = CStr(value.waarde)

            Case 53 'SampleID
                value.waarde = sfSample(Amount + 1).SampleName 'lookup samplename
                IntGen = value.waarde

            Case 54 'samplemode

                Select Case Amount
                    Case 1, 2
                        IntGen = "FwdLp"
                    Case 3
                        IntGen = "FwdLpEx"
                    Case Else
                        IntGen = "FwdNoLp"
                End Select

            Case 58 'overriding rootkey
                value.waarde = KeyStr(Amount) & " / " & CStr(Amount)
                IntGen = value.waarde
        End Select
    End Function

    Sub FillGenDesc()
        'fill array with generator descriptions

        GenDesc(0) = "startAddrsOffset"
        GenDesc(1) = "endAddrsOffset"
        GenDesc(2) = "startLoopAddrsOffset"
        GenDesc(3) = "endLoopAddrsOffset"
        GenDesc(4) = "startAddrsCoarseOffset"
        GenDesc(5) = "modLfoToPitch"
        GenDesc(6) = "vibLfoToPitch"
        GenDesc(7) = "modEnvToPitch"
        GenDesc(8) = "initialFilterFc"
        GenDesc(9) = "initialFilterQ"
        GenDesc(10) = "modLfoToFilterFc"
        GenDesc(11) = "modEnvToFilterFc"
        GenDesc(12) = "endAddrsCoarseOffset"
        GenDesc(13) = "modLfoToVolume"
        GenDesc(14) = "unused1"
        GenDesc(15) = "chorusEffetsSend"
        GenDesc(16) = "reverbEffectsSend"
        GenDesc(17) = "pan"
        GenDesc(18) = "unused2"
        GenDesc(19) = "unused3"
        GenDesc(20) = "unused4"
        GenDesc(21) = "delayModLfo"
        GenDesc(22) = "freqModLfo"
        GenDesc(23) = "delayVibLfo"
        GenDesc(24) = "freqVibLfo"
        GenDesc(25) = "delayModEnv"
        GenDesc(26) = "attackModEnv"
        GenDesc(27) = "holdModEnv"
        GenDesc(28) = "decayModEnv"
        GenDesc(29) = "sustainModEnv"
        GenDesc(30) = "releaseModEnv"
        GenDesc(31) = "keynumToModEnvHold"
        GenDesc(32) = "keynumToModEnvDecay"
        GenDesc(33) = "delayVolEnv"
        GenDesc(34) = "attackVolEnv"
        GenDesc(35) = "holdVolEnv"
        GenDesc(36) = "decayVolEnv"
        GenDesc(37) = "sustainVolEnv"
        GenDesc(38) = "releaseVolEnv"
        GenDesc(39) = "keynumToVolEnvHold"
        GenDesc(40) = "keynumToVolEnvDecay"
        GenDesc(41) = "instrument"
        GenDesc(42) = "reserved1"
        GenDesc(43) = "KeyRange"
        GenDesc(44) = "VelRange"
        GenDesc(45) = "startloppAddrsCoarseOffset"
        GenDesc(46) = "keynum"
        GenDesc(47) = "velocity"
        GenDesc(48) = "initialAttenuation"
        GenDesc(49) = "reserved2"
        GenDesc(50) = "endloopAddrsCoarseOffset"
        GenDesc(51) = "coarseTune"
        GenDesc(52) = "fineTune"
        GenDesc(53) = "SampleID"
        GenDesc(54) = "sampleModes"
        GenDesc(55) = "reserved3"
        GenDesc(56) = "scaleTuning"
        GenDesc(57) = "exclusiveClass"
        GenDesc(58) = "overridingRootKey"
        GenDesc(59) = "unused5"
        GenDesc(60) = "endOper"
    End Sub

    Sub InitKeyDesc()
        'initialize key descriptions
        KeyDesc(0) = "C"
        KeyDesc(1) = "C#"
        KeyDesc(2) = "D"
        KeyDesc(3) = "D#"
        KeyDesc(4) = "E"
        KeyDesc(5) = "F"
        KeyDesc(6) = "F#"
        KeyDesc(7) = "G"
        KeyDesc(8) = "G#"
        KeyDesc(9) = "A"
        KeyDesc(10) = "A#"
        KeyDesc(11) = "B"
    End Sub
    Function KeyStr(ByRef keynr As Integer) As String
        'gives back the key C-2 - G8 for a number
        KeyStr = KeyDesc(keynr Mod 12)
        KeyStr = KeyStr & CStr(Int(keynr / 12) - 2)
    End Function

    Function InputCheck(ByVal nFile As Byte, ByVal nBytes As Short) As String
        'reads from inputfile and stops after nonreadable characters to space
        'necessary for presets, instruments with nonreadable characters in name
        Dim i
        Dim c As String
        InputCheck = ""
        For i = 1 To nBytes
            c = InputString(nFile, 1)
            If Len(c) = 0 Then 'skip rest
                c = InputString(nFile, nBytes - i)
                Exit Function
            Else
                If (Asc(c) < 32) Or (Asc(c) > 126) Then
                    c = InputString(nFile, nBytes - i)
                End If
                InputCheck += c
            End If
        Next
    End Function
End Module