Option Strict Off
Option Explicit On
Module WriteStuff
	'this module contains routines for the output to a S1M file
	Public Cancelled As Boolean
	Public UniqueSample(2048) As Boolean 'unique sample: true when unique
	Public UniqueSampleNdx(2048) As Short
	Public nUniqueSamples As Short 'number of unique samples
	
	
	Sub WriteS1MInstrument(ByRef InstrNr As Short)
		'Write output file for One instrument
		'this is the instrument:
        Dim s As Integer
        Dim i As Integer
		'Call SetProgressBar
		
		
        InstrumentNode = NodSelect
        'onderstaande test al uitgevoerd
        'If InstrumentNode.GetNodeCount(False) = 0 Then
        '    s = MsgBox("No samples found", MsgBoxStyle.Critical, "Error")
        '    Cancelled = True
        '    Exit Sub
        'End If
        Cancelled = False
        Call OpenFiles()
        If Cancelled Then
            Exit Sub
        End If
        System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
        nUniqueSamples = 0
        For i = 1 To 2048
            UniqueSample(i) = False
        Next i
        Call CountUniqueSamples(InstrNr)
        Call WriteFileHeader()
        Call WriteSize(InstrNr)
        Call WritePointers()
        Call WriteWaveHeaders(InstrNr)
        Call WriteSampleHeaders(InstrNr)
        Call WriteRest(InstrNr)
        Call WriteSample(InstrNr)
        System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Default
	End Sub
	Sub OpenFiles()
		'open file for input and output

        'On Error Resume Next 'handel runtime error (=cancel) myself
        's = Mid(InstrumentNode.Text + "        ", 1, 8)
        Dim Illegalchars As String
        Dim FileName As String
        Dim SaveFileDlg As New SaveFileDialog
        Dim i, j As Integer
        Dim IllCharFound As Boolean

        Illegalchars = "\/:*?" & Chr(124)
        FileName = InstrumentNode.Text
        IllCharFound = False

        'check illegal characters in FileName
        For i = 0 To Len(FileName) - 1
            For j = 0 To Len(Illegalchars) - 1
                If FileName.Chars(i) = Illegalchars.Chars(j) Then
                    IllCharFound = True
                End If
            Next j
        Next i

        If IllCharFound Then
            FileName = "Instrument"
        End If

        SaveFileDlg.Title = "Save as EX5/7 Wave File"
        SaveFileDlg.Filter = "S1M Files (*.s1m)|*.s1m"
        SaveFileDlg.FileName = shPath + FileName + ".s1m"


        If SaveFileDlg.ShowDialog() = DialogResult.OK Then
            oFile = SaveFileDlg.FileName
        Else
            fMainForm.sbStatusBar.Panels(1).Text = "Save Cancelled - nothing saved"
            Cancelled = True
            Exit Sub
        End If

        FileOpen(1, sFile, OpenMode.Binary, OpenAccess.Read)
        FileOpen(2, oFile, OpenMode.Binary, OpenAccess.Write)
        fMainForm.sbStatusBar.Panels(1)._ObjectDefault = "Saving  " + oFile + "..."
        fMainForm.Refresh()
	End Sub
	Sub WriteFileHeader()
		Dim s As String
		s = "SY1200SPA  V1.00"
		FilePut(2, s)
		s = New String(Chr(&H0s), 111)
		s = s & New String(Chr(&H40s), 1)
        FilePut(2, s)
	End Sub
	
	Sub WriteSize(ByRef InstrNr As Short)
		'write size of waveheaderdata
		'caclulate size as follows: 12 bytes per waveheader + 18 bytes per layer (sample)
		'e.g. if there is 1 instrument with 4 saples: size is 12 + 4 * 18
		'
		Dim n As Integer : Dim i As Short
		Dim size As Integer
		Dim s As String
		n = InstrParams(InstrNr).LayerCount 'fout: inclusief global zones
		For i = 1 To 128
			If InstrParams(InstrNr).globalzone(i) Then n = n - 1 'correct for nr of global zones
		Next i
		size = 12 + n * 18
		n = nUniqueSamples 'number of unique samples
		s = MakeString(size, 4) & MakeString(n, 2)
        FilePut(2, s)
	End Sub
	Sub WritePointers()
		'write offset of waveheader data
		'fixed for 1 instrument: always &H0
        Dim s As String : Dim i As Integer
		s = New String(Chr(&H0s), 4)
        FilePut(2, s)
		For i = 1 To 1023 'rest
			s = New String(Chr(&HFFs), 4)
            FilePut(2, s)
		Next i
	End Sub
	Sub WriteWaveHeaders(ByRef InstrNr As Short)
		'write wave headers
		'fixed for 1 wave
		Dim s As String
		Dim j As Short
		Dim k As Integer
		Dim l As Integer
		Dim tel As Integer
		Dim nbytes As Integer
		Dim teller As Integer
		Dim i As Short
		Dim h As Integer
		
		tel = InstrParams(InstrNr).LayerCount
		teller = tel
		For i = 1 To 128 'correct for nr of global zones
			If InstrParams(InstrNr).globalzone(i) Then teller = teller - 1
		Next i
		
		'waveheader part
		s = Mid(InstrumentNode.Text & "        ", 1, 8) 'name, 8 bytes, fill with blanks
		s = s & MakeString(teller, 2) '# layers
		s = s & New String(Chr(&H0s), 2) 'unknown bytes
		
		'layer part
		teller = 0 'counts really written layers (excl. global)
		For j = 1 To tel 'for all samples in wave
			If InstrParams(InstrNr).globalzone(j) Then GoTo skippy ' skip global zone
			'k = InstrParams(InstrNr).SampleNdx(j) - 1   'base 0
			teller = teller + 1
			k = UniqueSampleNdx(InstrParams(InstrNr).SampleNdx(j)) - 1
			l = k Or &H4000s 'k = samplenr, set bit 14 to 1(=RAM sample)
			s = s & MakeString(l, 2)
			s = s & New String(Chr(&H0s), 1) 'output level, fixed on 127
			s = s & New String(Chr(&H0s), 1) 'unknown, fixed on &H0
			s = s & New String(Chr(InstrParams(InstrNr).LowKey(j)), 1)
			s = s & New String(Chr(InstrParams(InstrNr).HighKey(j)), 1)
			s = s & New String(Chr(InstrParams(InstrNr).VelLow(j)), 1)
			s = s & New String(Chr(InstrParams(InstrNr).VelHigh(j)), 1)
			'het lijkt erop of Frequency mode = fixed wordt veroorzaakt door een pan
			'van 128   (bit 8 set)
			h = Int(InstrParams(InstrNr).pan(j) / 500 * 64) + 64 'Pan
			If h > 127 Then h = 127
			s = s & New String(Chr(h), 1)
			h = Int(InstrParams(InstrNr).coarseTune(j) / 100 * 64) + 64
			If h > 127 Then h = 127
			s = s & New String(Chr(h), 1)
			h = Int(InstrParams(InstrNr).fineTune(j) / 100 * 64) + 64
			If h > 127 Then h = 127
			s = s & New String(Chr(h), 1)
			If teller > 1 Then
				s = s & New String(Chr(&H0s), 1) 'SamplePlay, already set in layer 1
			Else
				s = s & New String(Chr(&H40s), 1) 'SamplePlay, default
			End If
			s = s & New String(Chr(&H0s), 2) 'unknown
			s = s & New String(Chr(&H0s), 2) 'StartOffset
			s = s & New String(Chr(&H0s), 2) 'Loop length
skippy: 
		Next j
        FilePut(2, s)
		nbytes = 12 + teller * 18
		nbytes = 30720 - nbytes 'fixed for 1 wave; should change for more
		s = New String(Chr(&HFFs), nbytes)
        FilePut(2, s)
		
	End Sub
	Sub WriteSampleHeaders(ByRef InstrNr As Short)
		'write sample headers
		'NB a sample can be more than once in the waveheaders, but only once in the
		'sample section!
		'Value of start, startloop, end and endloop are cumulative in Soundfont file
		'therefore calculate real values by subtracting the startpoint of actual sample
		'(values are relative to startpoint)
		
		Dim i As Short
		Dim s As String
		Dim tel As Short
		Dim h As Integer
        Dim nsamples As Integer
		Dim SStart As Integer
		Dim SStartLoop As Integer
		Dim SEndLoop As Integer
		Dim SEnd As Integer
		Dim CumCorr As Integer 'cummulative correction
        Dim EX5Start(128) As Integer
        Dim EX5End(128) As Integer
		
		tel = InstrParams(InstrNr).LayerCount
        nsamples = 0
		CumCorr = 0
		For i = 1 To tel 'process all samples
			If Not UniqueSample(i) Then GoTo skippy 'if sample already processed: skip
			If InstrParams(InstrNr).globalzone(i) Then GoTo skippy 'skip global zone
            nsamples = nsamples + 1
			SStart = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart
			SStartLoop = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStartLoop
			SEndLoop = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEndLoop
			SEnd = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEnd
            EX5Start(nsamples) = SStart
            EX5End(nsamples) = SEnd
			'SStart = sfSample(nsamples).dwStart
			'SStartLoop = sfSample(nsamples).dwStartLoop
			'SEndLoop = sfSample(nsamples).dwEndLoop
			'SEnd = sfSample(nsamples).dwEnd
			s = Mid(sfSample(InstrParams(InstrNr).SampleNdx(i)).SampleName & "        ", 1, 8)
			s = s & New String(Chr(&H0s), 2) 'wave type, fixed for 16-bit sample
			h = SStartLoop - SStart
			If i > 1 Then
                h = h + EX5End(nsamples - 1)
			End If
			If i > 2 Then
                CumCorr = CumCorr + EX5Start(nsamples - 1) - EX5End(nsamples - 2) - 1
				h = h - CumCorr
			End If
			h = Int(h / 2) Or &HFC0000 'set bit 18-23
			s = s & MakeString(h, 3)
			Select Case InstrParams(InstrNr).samplemode(i)
				Case 1, 2
					s = s & New String(Chr(&H0s), 1) 'FwdLp, frachtion = 0
					'Case 3
					'FwdLpEx  TBD
				Case Else
					s = s & New String(Chr(&H40s), 1) 'FwdNoLp, fraction = 0
			End Select
			'If SEnd = SEndLoop Then
			'    s = s + String(1, &H40)             'FwdNoLp, fraction = 0
			'Else
			'    s = s + String(1, &H0)              'FwdLp, frachtion = 0
			'End If
			h = SStartLoop - SStart
			s = s & MakeString(h, 3)
			s = s & New String(Chr(&H0s), 1) 'fixed on FwdLp, LoopTune = 0
			h = SEndLoop - SStartLoop
			s = s & MakeString(h, 3)
			If InstrParams(InstrNr).OverridingRootKey(i) = -1 Then
                h = Asc(sfSample(InstrParams(InstrNr).SampleNdx(i)).byOriginalKey)
			Else
				h = InstrParams(InstrNr).OverridingRootKey(i)
			End If
			s = s & MakeString(h, 1)
			h = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart - SStart
			s = s & MakeString(h, 3)
			h = SEnd - SEndLoop
			s = s & MakeString(h, 3) 'number of unplayed samples; not in Soundfont?
            s = s & MakeString(nsamples - 1, 2) 'samplenumber, base0
            FilePut(2, s)
skippy: 
		Next i
		
		'fill other sample headers
        nsamples = nsamples + 1 'from number of samples + 1
        For i = nsamples To 1024
            s = "NewSampl" 'name
            's = s + MakeString(1, 2)        '# layers?
            s = s & MakeString(&H80S, 10) '6 byte number, fixed &H40
            's = s + MakeString(&H69FC, 3)   'sample length in words?
            s = s & MakeString(&H3CS, 4)
            s = s & New String(Chr(&H0S), 6)
            s = s & New String(Chr(&HFFS), 2)
            FilePut(2, s)
        Next i
	End Sub
	Sub WriteRest(ByRef InstrNr As Short)
		'write sample seizes in bytes
		'NB a sample can be more than once in the waveheaders, but only once in the
		'sample section!
		
		Dim i As Short
		Dim s As String
		Dim tel As Short
		Dim h As Integer
        Dim nsamples As Integer
		
		tel = InstrParams(InstrNr).LayerCount
        nsamples = 0
		For i = 1 To tel 'process all samples
			If Not UniqueSample(i) Then GoTo skippy 'if sample already processed: skip
			If InstrParams(InstrNr).globalzone(i) Then GoTo skippy 'skip global zone
            nsamples = nsamples + 1
			'h = Int(sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEnd - _
			'sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart)
			
			h = Int(sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEnd - sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart)
			h = h * 2 'translate in bytes
			s = MakeString(h, 4)
            FilePut(2, s)
skippy: 
		Next i
		
		'fill rest
        nsamples = nsamples + 1 'from number of samples + 1
        For i = nsamples To 1024
            s = New String(Chr(&H0S), 4)
            FilePut(2, s)
        Next i
	End Sub
	
	Sub WriteSample(ByRef InstrNr As Short)
		' write samples to file
		'NB a sample can be more than once in the waveheaders, but only once in the
		'sample section!
		
		Dim i As Short
		Dim j As Short
		Dim s As String
		Dim tel As Short
		Dim h As Integer
        Dim nsamples As Integer
		Dim length As Integer
		Dim TotLength As Integer
		Dim TotCounter As Integer
		Dim StartS As Integer
		Dim EndS As Integer
        Dim counter As Integer
        Dim b1 As Byte : Dim b2 As Byte
		
		
		tel = InstrParams(InstrNr).LayerCount
        nsamples = 0
		TotLength = 0 : TotCounter = 0
		For i = 1 To tel 'calculate total length
			If Not UniqueSample(i) Then GoTo skippy1 'if sample already processed: skip
            nsamples = nsamples + 1
			StartS = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart * 2 + strtSampleData
			EndS = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEnd * 2 + strtSampleData
			TotLength = TotLength + (EndS - StartS)
skippy1: 
		Next i
		
        nsamples = 0
		For i = 1 To tel 'process all samples
			If Not UniqueSample(i) Then GoTo skippy 'if sample already processed: skip
            counter = 1
            nsamples = nsamples + 1
			StartS = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwStart * 2 + strtSampleData
			EndS = sfSample(InstrParams(InstrNr).SampleNdx(i)).dwEnd * 2 + strtSampleData
			length = EndS - StartS
			
            fMainForm.ProgressBar1.Min = 0
            fMainForm.ProgressBar1.Max = TotLength + 1
            fMainForm.ProgressBar1.Visible = True
			
			Seek(1, StartS) 'position input file
            Do While counter < length
                FileGet(1, b1) 'read little endean
                FileGet(1, b2)
                FilePut(2, b2)
                FilePut(2, b1) 'write big endean
                counter += 2
                TotCounter += 2
                fMainForm.ProgressBar1.Value = TotCounter
            Loop
            'MsgBox ("sample size: " + Str(counter - 1))
skippy:
        Next i
		FileClose(1)
		FileClose(2)
		fMainForm.ProgressBar1.Visible = False
        fMainForm.sbStatusBar.Panels(1)._ObjectDefault = "File  " + oFile + "  was saved"
	End Sub
	
	
	Function MakeString(ByRef var As Integer, ByRef length As Short) As String
		'puts var in a string of length bytes, max 128 bytes
		'divided over necessary number of bytes
		Dim Number As Integer : Dim Fraction As Integer
        Dim s As String : Dim n As Integer : Dim j As Integer
        Dim b(128) As Byte
		Number = var
        n = 1
		'divide over n bytes
		Do While Number > 0
			Fraction = Int(Number / &H100s)
            b(n) = Number - Fraction * &H100S
			Number = Fraction
            n = n + 1
		Loop 
        n = n - 1 'n = number of bytes found > 0
		'compose ouputstring
		s = ""
        For j = 1 To length - n 'fill with &H0 from left
            s += CChar(CStr(Chr(&H0S)))
        Next j

        For j = n To 1 Step -1 'count backwards, lowest bite in b(1) etc
            s += CChar(CStr(Chr(b(j))))  'is waarsch. niet goed
        Next j
        MakeString = s
	End Function
	
	Sub CountUniqueSamples(ByRef InstrNr As Short)
		'count number of unique samples
		'a sample can be referenced in a wave more than once, but needs to be written
		'only once
		'corrected for global zone (26/7/03)
		
        Dim tel As Integer
        Dim i As Integer : Dim j As Integer
		Dim counter As Short
        tel = InstrParams(InstrNr).LayerCount 'tel = # layers incl. duplicates
        For i = 1 To tel 'process "all" samples
            For j = 1 To i - 1 'check if sample already processed
                If InstrParams(InstrNr).SampleNdx(i) = InstrParams(InstrNr).SampleNdx(j) Then GoTo skippy 'skip sample
            Next j
            If InstrParams(InstrNr).globalzone(i) Then GoTo skippy 'skip global zone
            UniqueSample(i) = True 'unique sample found
            counter = counter + 1 'number of unique samples found
            UniqueSampleNdx(InstrParams(InstrNr).SampleNdx(i)) = counter
skippy:
        Next i
        nUniqueSamples = counter
	End Sub
End Module