Attribute VB_Name = "SFStruct"
Option Base 0
Option Explicit

'In this module: Soundfont stuff
Public Type InfoChunkType
    ifil As String
    isng As String
    irom As String
    iver As String
    INAM As String
    ICRD As String
    IENG As String
    IPRD As String
    ICOP As String
    ICMT As String
    ISTF As String
End Type

Public Type sfPresetHeaderType
    achPresetName As String         'Preset name    20
    wPreset As Integer              'Preset number  2
    wBank As Integer                'Bank number    2
    wPresetBagNdx As Long           'Index in PBAG  4
    nZones As Integer               '# zones, calculate
    pFirstZone As Long              'points to first zone
End Type

Public Type sfPresetBagType
    wGenNdx As Long                 'Index to generator
    nGen As Integer                 'number of gnerators
    wModNdx As Long                 'Index to modulators
    nMod As Integer                 'number of modulators
    PresetHeaderNr As Long          'pointer to preset where this zone belongs to
End Type

Public Type sfInstrType
    achInstName As String            'Instrument naam 20
    wInstBag As Integer              'index 2
    nZones As Integer                'number of instrument zones
    iFirstZone As Long               'points to first zone
End Type

Public Type sfInstrBagType
    wInstGenNdx As Long                 'Index to generator
    nInstGen As Integer                 'number of gnerators
    wInstModNdx As Long                 'Index to modulators
    nInstMod As Integer                 'number of modulators
    InstrNr As Long                     'pointer to instrument where this zone belongs to
End Type

Public Type sfPModListType
    sfModSrcOper As Long
    sfModDestOper As Long
    modAmount As Long
    sfModAmtSrcOper As Long
    sfModTransOper As Long
    PBagNr As Integer               'pointer to presetzone
End Type

Public Type sfIModListType
    sfModSrcOper As Long
    sfModDestOper As Long
    modAmount As Long
    sfModAmtSrcOper As Long
    sfModTransOper As Long
    IBagNr As Integer               'pointer to presetzone
End Type

Public Type sfSampleType
    SampleName As String            'sample name    20
    dwStart As Long                 '               4
    dwEnd As Long                   '               4
    dwStartLoop As Long
    dwEndLoop As Long
    dwSampleRate As Long
    byOriginalKey As Variant
    chCorrection As Variant
    wSampleLink As Integer
    sfSampleType As Integer
End Type

Public Type SFStructure
    ckRIFFlen As Long               'RIFF size (= filesize - 8)
    ckINFOLen As Long               'size of INFO chunk
    ckSDTALen As Long               'Size of SDTA chunk
    smplLen As Long                 'Size of samples
    phdrLen As Long                 'Size of phdr
End Type

Public Type sfPGenListType
    sfGenOper As Long
    genAmount As Long
    PBagNr As Integer               'pointer to presetzone
End Type

Public Type sfIGenListType
    sfGenOper As Long
    genAmount As Long
    IBagNr As Integer               'pointer to Instrumentzone
End Type

Public Type ValueType               'user defined type as argument in procedures
    waarde As Variant
End Type

Public Type InstrParamType
    SampleNdx(2048) As Integer            'index to sample
    LayerCount As Integer          'index to n'th layer within instrument
    LowKey(2048) As Integer
    HighKey(2048) As Integer
    VelLow(2048) As Integer
    VelHigh(2048) As Integer
    coarseTune(2048) As Integer
    fineTune(2048) As Integer
    OverridingRootKey(2048) As Integer
    samplemode(2048) As Integer
    pan(2048) As Integer
    globalzone(128) As Boolean
End Type


Public sFile                    'name input file
Public oFile                    'name output File
Public fMainForm As frmMain
Public InstrParams(512) As InstrParamType
Public value As ValueType
Public SF As SFStructure
Public INFOChunk As InfoChunkType
Public sfPModList(4096) As sfPModListType
Public sfIModList(4096) As sfIModListType
Public sfPGenList(4096) As sfPGenListType
Public sfIGenList(64000) As sfIGenListType
Public sfSample(2048) As sfSampleType   'samples
Public nPresets
Public nInstruments
Public nsamples
Public sfInstr(512) As sfInstrType
Public lFileLen As Long                'Length of inputfile
Public bTel As Long                 'Number of bytes read
Public shFileName                   'short filename (without pathinfo)
Public shFileNoExt                  'short filename without extension
Public shPath                       'Path of input file
Public sfPresetBag(2048) As sfPresetBagType
Public sfInstrBag(4096) As sfInstrBagType
Public nPZones                      'number of preset Zones
Public nIZones                      'number of instrument zones
Public nPMods                       'number of modulators in P-zone
Public nPGens                       'number of generators in P-zone
Public nIMods                       'number of modulators in I-zone
Public nIGens                       'number of generators in I-zone
Public NodSelect As Node
Public InstrumentNode As Node
Public sfPresetHeader(512) As sfPresetHeaderType  'preset headers
Public strtSampleData As Long       'Start of Sample data in file
Public NodX As Node                    'different nodes in TreeView
Public Nod0 As Node
Public NodP As Node
Public NodI As Node
Public NodS As Node
Dim dummy As Variant                'used to skip bytes
Public GenDesc(60) As String
Public KeyDesc(11) As String

Sub LeesSFBestand()
'lees een soundfont bestand in
    
    Dim lang As Variant                 'Length of record read
    Dim i As Long                       'counter
    Dim j As Long                       'counter
    Dim k As Long                       'counter
    Dim sStatus As String               'Message fot statusbar
    Dim it As ListItem
    Dim s As String
    
    On Error GoTo 0
    Screen.MousePointer = vbHourglass
    'Get File Length
    lFileLen = FileLen(sFile)
    bTel = 0

    'handle user interface
    fMainForm.sbStatusBar.Panels(1) = "Processing..."
    fMainForm.TreeView1.Nodes.Clear
    fMainForm.Caption = "SF2S1"
    fMainForm.Refresh
    
    'read all the different chunks
    Call RIFFChunk                  'start reading Soundfontfile
    Call SubINFOChunk               'process Info chunk
    Call SMPLChunk                  'process sample data
    Call PHDRChunk                  'process preset header
    Call PBAGChunk                  'read presetbag
    Call PMODChunk                  'process Preset modulators
    Call PGENchunk                  'process Preset generators
    Call INSTChunk                  'proces instrument header data
    Call IBAGChunk                  'proces Instrument Bag
    Call IMODChunk                  'process Instrument modulators
    Call IGENchunk                  'process Instrument generators
    Call SHDRChunk                  'process Sample header data

'    Work on User inteface
    Call POPInstrNames
    Call PopSampleNames
    
    'set treeview to see presets/instruments/samples
    NodP.Expanded = False
    Nod0.EnsureVisible
    
    'write result in statusbar
    sStatus = Str(nPresets) + " presets, " + Str(nInstruments) + " instruments, "
    sStatus = sStatus + Str(nsamples) + " samples, one moment please..."
    fMainForm.sbStatusBar.Panels(1) = sStatus
    
    'write filename in formheader
    fMainForm.Caption = "SF2S1 - " + shFileName
    fMainForm.Refresh
    Screen.MousePointer = vbDefault
End Sub

Function lengte()
'Reads 4 bytes and interprets as a number
'little indean
    Dim som
    Dim a(4)
    Dim i
    som = 0
    For i = 1 To 4
        a(i) = Input(1, #1)
        som = som + Asc(a(i)) * (256 ^ (i - 1))
    Next i
    lengte = som
End Function

Function ReadWord()
'reads the next 2 bytes and interprets as a number
'little indean
    Dim som
    Dim a(2)
    Dim i
    som = 0
    For i = 1 To 2
        a(i) = Input(1, #1)
        som = som + Asc(a(i)) * (256 ^ (i - 1))
    Next i
    ReadWord = som
End Function

Sub CheckChunk(chunk As String)
'check if a required chunk is available, if not stop program
    Dim s As String
    s = Input(4, #1)
    If Not (StrComp(s, chunk) = 0) Then
        MsgBox ("Error in SoundFont File. Program will End")
        End
    End If
End Sub
Sub RIFFChunk()
'process start of soundfontfile
    CheckChunk ("RIFF")              'RIFF?
    SF.ckRIFFlen = lengte()
    CheckChunk ("sfbk")              'sfbk?
    CheckChunk ("LIST")              '"LIST"
    SF.ckINFOLen = lengte()          'lengte van INFO-list
    CheckChunk ("INFO")
End Sub

Sub SubINFOChunk()
'Processes INFO chunck
    Dim chunkname
    Dim i
    Dim j
    Dim BR As Long
    Do
        chunkname = Input(4, #1)
        Select Case chunkname
        Case "ifil"
            BR = lengte()           'skip sizebytes
            i = ReadWord()
            j = ReadWord()
            INFOChunk.ifil = Str(i + j / 100)
        Case "isng"
            BR = lengte()
            INFOChunk.isng = Input(BR, #1)
        Case "irom"
            BR = lengte()
            INFOChunk.irom = Input(BR, #1)
        Case "iver"
            BR = lengte()           'skip sizebytes
            i = ReadWord()
            j = ReadWord()
            INFOChunk.iver = Str(i + j / 100)
        Case "INAM"
            BR = lengte()
            INFOChunk.INAM = Input(BR, #1)
        Case "IPRD"
            BR = lengte()
            INFOChunk.IPRD = Input(BR, #1)
        Case "ICRD"
            BR = lengte()
            INFOChunk.ICRD = Input(BR, #1)
        Case "IENG"
            BR = lengte()
            INFOChunk.IENG = Input(BR, #1)
        Case "ICOP"
            BR = lengte()
            INFOChunk.ICOP = Input(BR, #1)
        Case "ICMT"
            BR = lengte()
            INFOChunk.ICMT = Input(BR, #1)
        Case "ISFT"
            BR = lengte()
            INFOChunk.ISTF = Input(BR, #1)
        End Select
    Loop Until chunkname = "LIST"
End Sub

Sub SMPLChunk()
'process sample data
Dim fLoc As Long                    'File Location
    SF.ckSDTALen = lengte()
    CheckChunk ("sdta")             'check "sdta"
    CheckChunk ("smpl")             'check "smpl"
    SF.smplLen = lengte()
    fLoc = Seek(1)                  'skip sampledata...
    strtSampleData = fLoc          '...but keep startbyte in mind (first byte = 1)
    fLoc = fLoc + SF.smplLen
    Seek #1, fLoc
End Sub
Sub PHDRChunk()
'process phdr chunck
    Dim i
    Dim lang As Long
    CheckChunk ("LIST")             'skip "LIST"
    lang = lengte()                 'skip size bytes
    CheckChunk ("pdta")             ' check pdta chunk
    CheckChunk ("phdr")             'skip "phdr"
    SF.phdrLen = lengte()
    'write level 1 nodes
    Set Nod0 = fMainForm.TreeView1.Nodes.Add(, , "node1", shFileName, 6)
    Set NodP = fMainForm.TreeView1.Nodes.Add(Nod0, tvwChild, "nodeP", "Presets", 20)
    Set NodI = fMainForm.TreeView1.Nodes.Add(Nod0, tvwChild, "nodeI", "Instruments", 21)
    Set NodS = fMainForm.TreeView1.Nodes.Add(Nod0, tvwChild, "nodeS", "Samples", 22)
    i = 0: nPZones = 0
    Do                              'read phdr and populate treeview
        i = i + 1                       '= number of presets
        sfPresetHeader(i).achPresetName = Input(20, #1)
        sfPresetHeader(i).wPreset = ReadWord()
        sfPresetHeader(i).wBank = ReadWord()
        sfPresetHeader(i).wPresetBagNdx = ReadWord()
        dummy = Input(12, #1)                'skip rest preset 3 * doubleword
        If i > 1 Then       'calculate # zones, from i = 2
            sfPresetHeader(i - 1).nZones = sfPresetHeader(i).wPresetBagNdx - _
                sfPresetHeader(i - 1).wPresetBagNdx
            nPZones = nPZones + sfPresetHeader(i - 1).nZones
            'Set NodX = fMainForm.TreeView1.Nodes.Add("nodeP" + CStr(i - 1), _
                tvwChild, "zones" + CStr(i - 1), Str(sfPresetHeader(i - 1).nZones) _
                + " zones", 1)
        End If
        If Mid(sfPresetHeader(i).achPresetName, 1, 3) = "EOP" Then Exit Do
       Set NodX = fMainForm.TreeView1.Nodes.Add(NodP, tvwChild, "nodeP" + CStr(i), _
            sfPresetHeader(i).achPresetName, 20)
        NodX.EnsureVisible
        fMainForm.TreeView1.Refresh
    Loop
    nPresets = i - 1                    'last preset header is dummy

End Sub
Sub PMODChunk()
'process PMOD chunk
    Dim i
    Dim j
    Dim k
    Dim lang As Long
    Dim nbytes As Long
    
    CheckChunk ("pmod")             'test if pmod-rec
    lang = lengte()                 'read size
    
    k = 0
    nbytes = 0
    For i = 1 To nPZones            'i = PZonenumber
        For j = 1 To sfPresetBag(i).nMod  'j = Modulatornumber in PZone
            k = k + 1             'k =  number of modulators
            sfPModList(k).sfModSrcOper = ReadWord()
            sfPModList(k).sfModDestOper = ReadWord()
            sfPModList(k).modAmount = ReadWord()
            sfPModList(k).sfModAmtSrcOper = ReadWord()
            sfPModList(k).sfModTransOper = ReadWord()
            sfPModList(k).PBagNr = i     'pointer back to bag where modulator belongs
            nbytes = nbytes + 10          '= number of bytes read in pmod chunk
        Next j
    Next i
    'nPGens = MsgBox(Str(k), , "Number of Modulators in pGen")
    dummy = Input(10, #1)         'read last dummy record
End Sub
Sub init()
'init global variables
Dim i: Dim j
    nPresets = 0
    nPZones = 0
    nInstruments = 0
    nsamples = 0
    nInstruments = 0
    nPMods = 0
    nPGens = 0
    Call FillGenDesc
    Call InitKeyDesc
    For i = 1 To 512
        For j = 1 To 2048
            InstrParams(i).OverridingRootKey(j) = -1
            InstrParams(i).VelLow(j) = 1
            InstrParams(i).VelHigh(j) = 127
        Next j
        For j = 1 To 128
            InstrParams(i).globalzone(j) = False
        Next j
    Next i
    'For i = 1 To 2048
    '    sfSample(i).byOriginalKey = 60
    'Next i
End Sub
Sub PGENchunk()
'read PGEN chunk
    Dim i
    Dim j
    Dim k
    Dim nbytes
    Dim lang As Long
    CheckChunk ("pgen")        'pgen-rec
    lang = lengte()
    i = 0: j = 0: k = 0
    nbytes = 0
    For i = 1 To nPZones                    'i = PZonenumber
        For j = 1 To sfPresetBag(i).nGen    'j = Generatornumber in PZone
            k = k + 1                       'k =  number of generators
            sfPGenList(k).sfGenOper = ReadWord()
            sfPGenList(k).genAmount = ReadWord()
            sfPGenList(k).PBagNr = i     'pointer back to bag where generator belongs
            nbytes = nbytes + 4          '= number of bytes read in pgen chunk
        Next j
    Next i
    'nPGens = MsgBox(Str(k), , "Number of Generators in pGen")
    dummy = Input(4, #1)         'read last dummy record

End Sub

Sub PBAGChunk()
'process zones in PBAG chunk
    Dim lang As Long
    Dim i
    Dim j
    Dim k
    
    CheckChunk ("pbag")             'pbag-rec
    lang = lengte()
    For i = 1 To nPZones + 1        'one more to process terminal zone
        sfPresetBag(i).wGenNdx = ReadWord()
        sfPresetBag(i).wModNdx = ReadWord()
    Next i
   ' Dummy = Input(4, #1)         'read last dummy record
    
    'identify  zones per preset
    k = 0: nPMods = 0: nPGens = 0
    For i = 1 To nPresets        'i = presetnumber
        'write preset in tree
        sfPresetHeader(i).pFirstZone = k + 1
        For j = 1 To sfPresetHeader(i).nZones     'j = zonenumber within presetzone
            k = k + 1            'k is actual zonenumber in pbag
            'Set NodX = fMainForm.TreeView1.Nodes.Add("zones" + CStr(i), tvwChild, _
                "PModu" + CStr(k), "Mod " + CStr(j), 1)
            Set NodX = fMainForm.TreeView1.Nodes.Add("nodeP" + CStr(i), tvwChild, _
                "PGene" + CStr(k), "Gen " + CStr(j), 21)
            sfPresetBag(k).PresetHeaderNr = i       'set pointer back to preset
            If k > 1 Then       'calculate # mods end gens, starting from k = 2
                sfPresetBag(k - 1).nMod = sfPresetBag(k).wModNdx - _
                    sfPresetBag(k - 1).wModNdx
                nPMods = nPMods + sfPresetBag(k - 1).nMod
                sfPresetBag(k - 1).nGen = sfPresetBag(k).wGenNdx - _
                    sfPresetBag(k - 1).wGenNdx
                nPGens = nPGens + sfPresetBag(k - 1).nGen
            End If
        Next j
    Next i
    'process terminal zone
    k = k + 1
    If k > 1 Then
        sfPresetBag(k - 1).nMod = sfPresetBag(k).wModNdx - sfPresetBag(k - 1).wModNdx
        nPMods = nPMods + sfPresetBag(k - 1).nMod
        sfPresetBag(k - 1).nGen = sfPresetBag(k).wGenNdx - sfPresetBag(k - 1).wGenNdx
        nPGens = nPGens + sfPresetBag(k - 1).nGen
    End If
End Sub
Sub INSTChunk()
'read Instrument chunk
    Dim i
    Dim lang As Long
    CheckChunk ("inst")        'inst-rec
    lang = lengte()
     i = 0: nIZones = 0
    Do                      'lees instrumentrecords en zet in tree
        i = i + 1
        sfInstr(i).achInstName = Input(20, #1)
        'If EOF(1) Then Exit Do
        sfInstr(i).wInstBag = ReadWord()
        If i > 1 Then       'calculate # zones, from i = 2
            sfInstr(i - 1).nZones = sfInstr(i).wInstBag - _
                sfInstr(i - 1).wInstBag
            nIZones = nIZones + sfInstr(i - 1).nZones
            'Set NodX = fMainForm.TreeView1.Nodes.Add("nodeI" + CStr(i - 1), _
                tvwChild, "izone" + CStr(i - 1), Str(sfInstr(i - 1).nZones) _
                + " zones", 1)
        End If
        If Mid(sfInstr(i).achInstName, 1, 3) = "EOI" Then Exit Do
        Set NodX = fMainForm.TreeView1.Nodes.Add(NodI, tvwChild, "nodeI" + CStr(i), _
            sfInstr(i).achInstName, 21)
    Loop
    nInstruments = i - 1        'last is dummy record
End Sub
Sub IBAGChunk()
'process zones in PBAG chunk, copied and modified from PBAGChunk
    Dim lang As Long
    Dim i
    Dim j
    Dim k
    
    CheckChunk ("ibag")             'ibag-rec
    lang = lengte()
    For i = 1 To nIZones + 1        'one more to process terminal zone
        sfInstrBag(i).wInstGenNdx = ReadWord()
        sfInstrBag(i).wInstModNdx = ReadWord()
    Next i
 
    
    'identify zones per Instrument
    k = 0: nIMods = 0: nIGens = 0
    For i = 1 To nInstruments        'i = instrumentnumber
        'write instrument in tree
        sfInstr(i).iFirstZone = k + 1
        For j = 1 To sfInstr(i).nZones      'j = zonenumber within instr.zone
            k = k + 1            'k is actual zonenumber in pbag
            'Set NodX = fMainForm.TreeView1.Nodes.Add("izone" + CStr(i), tvwChild, _
                "IModu" + CStr(k), "Mod " + CStr(j), 1)
            Set NodX = fMainForm.TreeView1.Nodes.Add("nodeI" + CStr(i), tvwChild, _
                "IGene" + CStr(k), "Gen " + CStr(j), 22)
            sfInstrBag(k).InstrNr = i        'set pointer back to instrument
            If k > 1 Then       'calculate # mods and gens, starting from k = 2
                sfInstrBag(k - 1).nInstMod = sfInstrBag(k).wInstModNdx - _
                    sfInstrBag(k - 1).wInstModNdx
                nIMods = nIMods + sfInstrBag(k - 1).nInstMod
                sfInstrBag(k - 1).nInstGen = sfInstrBag(k).wInstGenNdx - _
                    sfInstrBag(k - 1).wInstGenNdx
                nIGens = nIGens + sfInstrBag(k - 1).nInstGen
            End If
        Next j
    Next i
    'process terminal zone
    k = k + 1
    If k > 1 Then
        sfInstrBag(k - 1).nInstMod = sfInstrBag(k).wInstModNdx _
            - sfInstrBag(k - 1).wInstModNdx
        nIMods = nIMods + sfInstrBag(k - 1).nInstMod
        sfInstrBag(k - 1).nInstGen = sfInstrBag(k).wInstGenNdx _
            - sfInstrBag(k - 1).wInstGenNdx
        nIGens = nIGens + sfInstrBag(k - 1).nInstGen
    End If
End Sub

Sub IMODChunk()
'process PMOD chunk
    Dim i
    Dim j
    Dim k
    Dim lang As Long
    Dim nbytes As Long
    
    CheckChunk ("imod")             'test if imod-rec
    lang = lengte()                 'read size
    
    k = 0
    nbytes = 0
    For i = 1 To nIZones            'i = IZonenumber
        For j = 1 To sfInstrBag(i).nInstMod   'j = Modulatornumber in IZone
            k = k + 1             'k =  number of modulators
            sfIModList(k).sfModSrcOper = ReadWord()
            sfIModList(k).sfModDestOper = ReadWord()
            sfIModList(k).modAmount = ReadWord()
            sfIModList(k).sfModAmtSrcOper = ReadWord()
            sfIModList(k).sfModTransOper = ReadWord()
            sfIModList(k).IBagNr = i     'pointer back to bag where modulator belongs
            nbytes = nbytes + 10          '= number of bytes read in pmod chunk
        Next j
    Next i
    'nPGens = MsgBox(Str(k), , "Number of Modulators in pGen")
    dummy = Input(10, #1)         'read last dummy record
End Sub

Sub IGENchunk()
'read IGEN chunk
    Dim i
    Dim j
    Dim k
    Dim nbytes
    Dim lang As Long
    
    CheckChunk ("igen")        'igen-rec
    lang = lengte()
    i = 0: j = 0: k = 0
    nbytes = 0
    For i = 1 To nIZones                    'i = IZonenumber
        For j = 1 To sfInstrBag(i).nInstGen 'j = Generatornumber in IZone
            k = k + 1                       'k =  number of generators
            sfIGenList(k).sfGenOper = ReadWord()
            sfIGenList(k).genAmount = ReadWord()
            sfIGenList(k).IBagNr = i     'pointer back to bag where generator belongs
            nbytes = nbytes + 4          '= number of bytes read in pmod chunk
        Next j
    Next i
    'nIGens = MsgBox(Str(k), , "Number of Generators in IGen")
    dummy = Input(4, #1)         'read last dummy record
End Sub

Sub SHDRChunk()
'proces shdr chunk

    Dim i
    Dim lang As Long
    CheckChunk ("shdr")        'shdr-rec
    lang = lengte()
    i = 0
    Do              'populate TreeView with samples
        i = i + 1
        sfSample(i).SampleName = Input(20, #1)
        sfSample(i).dwStart = lengte()
        sfSample(i).dwEnd = lengte()
        sfSample(i).dwStartLoop = lengte()
        sfSample(i).dwEndLoop = lengte()
        sfSample(i).dwSampleRate = lengte()
        sfSample(i).byOriginalKey = Input(1, #1)
        sfSample(i).chCorrection = Input(1, #1)
        sfSample(i).wSampleLink = ReadWord()
        sfSample(i).sfSampleType = ReadWord()
        If EOF(1) Then Exit Do
        If Mid(sfSample(i).SampleName, 1, 3) = "EOS" Then Exit Do
        Set NodX = fMainForm.TreeView1.Nodes.Add(NodS, tvwChild, "nodeS" + CStr(i), _
            sfSample(i).SampleName, 22)
    Loop
    nsamples = i - 1
End Sub

Sub PopSampleNames()
'populate sample names in Treeview
'inspect all Zones and fill Instrument Parameters (InstrParams)
'identify global zones
'interpret instrument generators


Dim i As Integer: Dim j As Integer: Dim k As Long
Dim l As Integer: Dim m As Integer: Dim n As Integer
Dim IZone As Integer
Dim SampleName As String
    k = 0: IZone = 0
    'reset LayerCount per Instrument (needed if new SF read)
    For i = 1 To 512
        InstrParams(i).LayerCount = 0
    Next i
    
    For m = 1 To nInstruments           'go through all instruments
    InstrParams(m).LayerCount = sfInstr(m).nZones
     For i = 1 To sfInstr(m).nZones      'walk through Zones per instrument
      IZone = IZone + 1                 'Izone = cumulative zonenumber
      For j = 1 To sfInstrBag(IZone).nInstGen 'go through generators / zone
        'j = sfInstrBag(i).nInstGen          'j = last Generatornumber in IZone
        k = k + 1                           'keep track of cumulative number
        SampleName = "global"
        l = sfIGenList(k).IBagNr        'path back to Instrument Bag
        'n = sfInstrBag(l).InstrNr       'path back to Instrument
    
        
    Select Case sfIGenList(k).sfGenOper  'process different generators
    
        Case 17     'pan
            If sfIGenList(k).genAmount > 32678 Then
                InstrParams(m).pan(i) = _
                    (65536 - sfIGenList(k).genAmount) * -1
            Else
                InstrParams(m).pan(i) = sfIGenList(k).genAmount
            End If
        
        Case 43        'keyRange generator
            InstrParams(m).HighKey(i) = Int(sfIGenList(k).genAmount / 256)
            InstrParams(m).LowKey(i) = Int(sfIGenList(k).genAmount - _
                InstrParams(m).HighKey(i) * 256)
        
        Case 44        'Velocity Range generator
            InstrParams(m).VelHigh(i) = Int(sfIGenList(k).genAmount / 256)
            InstrParams(m).VelLow(i) = Int(sfIGenList(k).genAmount - _
                InstrParams(m).HighKey(i) * 256)
                
        Case 51  'coarse Tune
            If sfIGenList(k).genAmount > 32678 Then
                InstrParams(m).coarseTune(i) = _
                    (65536 - sfIGenList(k).genAmount) * -1
            Else
                InstrParams(m).coarseTune(i) = sfIGenList(k).genAmount
            End If
            
        Case 52  'fine Tune
            If sfIGenList(k).genAmount > 32678 Then
                InstrParams(m).fineTune(i) = _
                    (65536 - sfIGenList(k).genAmount) * -1
            Else
                InstrParams(m).fineTune(i) = sfIGenList(k).genAmount
            End If
            
        Case 53       'SamplID generator?
            SampleName = IntGen(sfIGenList(k).sfGenOper, sfIGenList(k).genAmount)
            InstrParams(m).SampleNdx(i) = sfIGenList(k).genAmount + 1
          
        Case 54       'SampleMode
            InstrParams(m).samplemode(i) = sfIGenList(k).genAmount
                
        Case 58  'overriding Root Key present?
            InstrParams(m).OverridingRootKey(i) = sfIGenList(k).genAmount
            
        End Select
       Next j
       
      fMainForm.TreeView1.Nodes("IGene" + CStr(IZone)).Text = SampleName
      If SampleName = "global" Then        'exclude global zone from processing
        InstrParams(m).globalzone(i) = True
      End If
      
    Next i
    Next m
End Sub

Sub POPInstrNames()
'populate Instrument names in Treeview
Dim i: Dim j: Dim k:
Dim InstrName
    k = 0
    For i = 1 To nPZones                'walk through all IZones
        j = sfPresetBag(i).nGen           'j = last Generatornumber in PZone
        k = k + j                           'keep track of cumulative number
        'write instrument name in Treeview (or) 'Global'
        If sfPGenList(k).sfGenOper = 41 Then       'Instrument generator?
            InstrName = IntGen(sfPGenList(k).sfGenOper, sfPGenList(k).genAmount)
        Else
            InstrName = "global"
        End If
        'MsgBox InstrName
        fMainForm.TreeView1.Nodes("PGene" + CStr(i)).Text = InstrName
    Next i
End Sub

Function IntGen(PGen, Amount)
'interpret value of generator parameter
Dim LS As Integer
Dim MS As Integer
    IntGen = Amount     'if not recognized just return value
    Select Case PGen    'if recognized as...
        
        Case 17         'pan
            If Amount > 32678 Then
                value.waarde = (65536 - Amount) * -1
            Else
                value.waarde = Amount
            End If
            IntGen = value.waarde
            
        Case 43         'KeyRange
            MS = Int(Amount / 256)      'MS = to key
            LS = Int(Amount - MS * 256) 'LS = from key
            value.waarde = KeyStr(LS) + " - " + KeyStr(MS) + _
                " / " + CStr(LS) + " - " + CStr(MS)
            IntGen = value.waarde
            
        Case 41         'instrument
            value.waarde = sfInstr(Amount + 1).achInstName 'lookup instrumentname
            IntGen = value.waarde
            
            
        Case 44         'Velocity Range
            MS = Int(Amount / 256)      'MS = to key
            LS = Int(Amount - MS * 256) 'LS = from key
            value.waarde = CStr(LS) + " - " + CStr(MS)
            IntGen = value.waarde
            
        Case 52         'fine Tune
            If Amount > 32678 Then
                value.waarde = (65536 - Amount) * -1
            Else
                value.waarde = Amount
            End If
            IntGen = value.waarde
            
        Case 53         'SampleID
            value.waarde = sfSample(Amount + 1).SampleName 'lookup samplename
            IntGen = value.waarde
            
        Case 54         'samplemode
            
            Select Case Amount
            Case 1, 2
                IntGen = "FwdLp"
            Case 3
                IntGen = "FwdLpEx"
            Case Else
                IntGen = "FwdNoLp"
            End Select
            
        Case 58         'overriding rootkey
            value.waarde = KeyStr(Amount) + " / " + CStr(Amount)
            IntGen = value.waarde
    End Select
End Function

Sub FillGenDesc()
'fill array with generator descriptions

    GenDesc(0) = "startAddrsOffset"
    GenDesc(1) = "endAddrsOffset"
    GenDesc(2) = "startLoopAddrsOffset"
    GenDesc(3) = "endLoopAddrsOffset"
    GenDesc(4) = "startAddrsCoarseOffset"
    GenDesc(5) = "modLfoToPitch"
    GenDesc(6) = "vibLfoToPitch"
    GenDesc(7) = "modEnvToPitch"
    GenDesc(8) = "initialFilterFc"
    GenDesc(9) = "initialFilterQ"
    GenDesc(10) = "modLfoToFilterFc"
    GenDesc(11) = "modEnvToFilterFc"
    GenDesc(12) = "endAddrsCoarseOffset"
    GenDesc(13) = "modLfoToVolume"
    GenDesc(14) = "unused1"
    GenDesc(15) = "chorusEffetsSend"
    GenDesc(16) = "reverbEffectsSend"
    GenDesc(17) = "pan"
    GenDesc(18) = "unused2"
    GenDesc(19) = "unused3"
    GenDesc(20) = "unused4"
    GenDesc(21) = "delayModLfo"
    GenDesc(22) = "freqModLfo"
    GenDesc(23) = "delayVibLfo"
    GenDesc(24) = "freqVibLfo"
    GenDesc(25) = "delayModEnv"
    GenDesc(26) = "attackModEnv"
    GenDesc(27) = "holdModEnv"
    GenDesc(28) = "decayModEnv"
    GenDesc(29) = "sustainModEnv"
    GenDesc(30) = "releaseModEnv"
    GenDesc(31) = "keynumToModEnvHold"
    GenDesc(32) = "keynumToModEnvDecay"
    GenDesc(33) = "delayVolEnv"
    GenDesc(34) = "attackVolEnv"
    GenDesc(35) = "holdVolEnv"
    GenDesc(36) = "decayVolEnv"
    GenDesc(37) = "sustainVolEnv"
    GenDesc(38) = "releaseVolEnv"
    GenDesc(39) = "keynumToVolEnvHold"
    GenDesc(40) = "keynumToVolEnvDecay"
    GenDesc(41) = "instrument"
    GenDesc(42) = "reserved1"
    GenDesc(43) = "KeyRange"
    GenDesc(44) = "VelRange"
    GenDesc(45) = "startloppAddrsCoarseOffset"
    GenDesc(46) = "keynum"
    GenDesc(47) = "velocity"
    GenDesc(48) = "initialAttenuation"
    GenDesc(49) = "reserved2"
    GenDesc(50) = "endloopAddrsCoarseOffset"
    GenDesc(51) = "coarseTune"
    GenDesc(52) = "fineTune"
    GenDesc(53) = "SampleID"
    GenDesc(54) = "sampleModes"
    GenDesc(55) = "reserved3"
    GenDesc(56) = "scaleTuning"
    GenDesc(57) = "exclusiveClass"
    GenDesc(58) = "overridingRootKey"
    GenDesc(59) = "unused5"
    GenDesc(60) = "endOper"
End Sub

Sub InitKeyDesc()
'initialize key descriptions
    KeyDesc(0) = "C"
    KeyDesc(1) = "C#"
    KeyDesc(2) = "D"
    KeyDesc(3) = "D#"
    KeyDesc(4) = "E"
    KeyDesc(5) = "F"
    KeyDesc(6) = "F#"
    KeyDesc(7) = "G"
    KeyDesc(8) = "G#"
    KeyDesc(9) = "A"
    KeyDesc(10) = "A#"
    KeyDesc(11) = "B"
End Sub
Function KeyStr(keynr As Variant) As String
'gives back the key C-2 - G8 for a number
    KeyStr = KeyDesc(keynr Mod 12)
    KeyStr = KeyStr + CStr(Int(keynr / 12) - 2)
End Function
